/* 
 * Copyright (C) 2010, 2011 johnc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef COMMUNICATE_H_
#define COMMUNICATE_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

// POST header format, after which there should be contents, which is the string to
// 		be translated
// %d is where Content-Length is inserted
#define POST_FMT "POST / HTTP/1.0\r\nAccept: */*\r\n"\
	"User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727)\r\n"\
	"Content-length: %d\r\nHost: translate.google.com\r\n\r\n"

// Don't be silly. You do NOT want to rely on Google Translate, it's just not that good.
// 512 is more than enough for you.
#define SIZE_LIMIT 512

int gt_socket();
int gt_send(int sock, const char *from);
void gt_recv(int sock, char *result);
inline void gt_close(int sock);
#endif
