/* 
 * Copyright (C) 2010, 2011 johnc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 */

// Obtain PREFIX, KEYBINDING, APP_NAME_GEN
#include "gconf-keybinding.h"

static void
setup_keybinding()
{
	GConfClient *client;
	client = gconf_client_get_default();
	// %d is 1 to 12, whose length is 45 at most
	gchar *cmd_key_fmt = "/apps/metacity/keybinding_commands/command_%d";
	// length is 48 at most
	gchar *bind_key_fmt = "/apps/metacity/global_keybindings/run_command_%d";
	gchar cmd_key[46], bind_key[49];
	gchar *value;

	gchar *path = (gchar *)malloc(strlen(PREFIX) + strlen(APP_NAME_GEN) + 1);
	path[0] = '\0';
	strcat(path, PREFIX);
	strcat(path, APP_NAME_GEN);

	gint idx;
	for(idx = 1; idx <= 12; ++idx)
	{
		sprintf(cmd_key, cmd_key_fmt, idx);
		value = gconf_client_get_string(client, cmd_key, NULL);
		if(strlen(value) == 0){
			gconf_client_set_string(client, cmd_key, path, NULL);
			sprintf(bind_key, bind_key_fmt, idx);
			gconf_client_set_string(client, bind_key, KEYBINDING, NULL);
			break;
		}else if(!strcmp(value, path)){
			sprintf(bind_key, bind_key_fmt, idx);
			gconf_client_set_string(client, bind_key, KEYBINDING, NULL);
			break;
		}
		g_free(value);
	}
}

int
main(int argc, char *argv[])
{
	setup_keybinding();
}
