/* 
 * Copyright (C) 2010, 2011 johnc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "translate.h"
#include "gtranslator.h"

// One Window to Rule Them All ...
int
main( int argc, char *argv[])
{
	GtkWidget *window;
   	GtkWidget *frm_label, *to_label;
   	GtkWidget *vbox, *hbox;
   	GtkWidget *hsep;
   	GtkWidget *about, *quit;

	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
   	gtk_window_set_default_size(GTK_WINDOW(window), 400, 400);
   	gtk_window_set_title(GTK_WINDOW(window), APP_NAME_TITLE);

	gtk_container_set_border_width(GTK_CONTAINER(window), 20);

	gchar plain[SIZE_LIMIT] = "\0";
	gchar result[SIZE_LIMIT] = "\0";
	gint clipbrd_len;

	clipbrd_len = win_get_clipbrd(plain);

	frm_label = gtk_label_new(plain);
	gtk_label_set_line_wrap(GTK_LABEL(frm_label), TRUE);
	gtk_label_set_selectable(GTK_LABEL(frm_label), TRUE);

	if(clipbrd_len == 1)
		gtranslate(plain, result);

	to_label = gtk_label_new(result);
	gtk_label_set_line_wrap(GTK_LABEL(to_label), TRUE);
	gtk_label_set_selectable(GTK_LABEL(to_label), TRUE);

	hsep = gtk_hseparator_new();
	  
	hbox = gtk_hbox_new(FALSE, 0);
	about = gtk_button_new_with_label("About");
	quit = gtk_button_new_with_label("Quit");
	g_signal_connect(G_OBJECT(about), "clicked", G_CALLBACK(win_show_about),
		   	G_OBJECT(window));

	g_signal_connect(G_OBJECT(quit), "clicked", G_CALLBACK(gtk_main_quit), 
			  G_OBJECT(window));
	
	gtk_box_pack_start(GTK_BOX(hbox), about, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), quit, TRUE, FALSE, 0);

	vbox = gtk_vbox_new(FALSE, 10);
	gtk_container_add(GTK_CONTAINER(window), vbox);

	gtk_box_pack_start(GTK_BOX(vbox), frm_label, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hsep, FALSE, TRUE, 10);
	gtk_box_pack_start(GTK_BOX(vbox), to_label, FALSE, TRUE, 0);
	gtk_box_pack_end(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);

	gtk_window_set_focus(GTK_WINDOW(window), about);

	g_signal_connect(G_OBJECT(window), "key-press-event",
			G_CALLBACK(win_key_pressed), NULL);

	g_signal_connect_swapped(G_OBJECT(window), "destroy",
			G_CALLBACK(gtk_main_quit), NULL);

	gtk_widget_show_all(window);

	gtk_main();

	return 0;
}
