/* 
 * Copyright (C) 2010, 2011 johnc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "translate.h"
#include "gtranslator.h"

void
win_show_about(GtkWidget *widget, gpointer data)
{
	GtkWidget *dialog = gtk_about_dialog_new();
	gtk_about_dialog_set_name(GTK_ABOUT_DIALOG(dialog), APP_NAME_TITLE);
	gtk_about_dialog_set_version(GTK_ABOUT_DIALOG(dialog), "0.2");
	gtk_about_dialog_set_copyright(GTK_ABOUT_DIALOG(dialog), 
			"Copyright (c) 2010, 2011 johnc");
	gtk_about_dialog_set_comments(GTK_ABOUT_DIALOG(dialog), 
			"Translate text in clipboard using\ntranslate.google.com");
	gtk_about_dialog_set_website(GTK_ABOUT_DIALOG(dialog), 
			"http://www.googies.info");
	gtk_dialog_run(GTK_DIALOG (dialog));
	gtk_widget_destroy(dialog);
}

// when "ESC" is pressed, exit
gboolean
win_key_pressed(GtkWidget *widget, GdkEventKey *event)
{
	switch(event->keyval){
	case GDK_KEY_Escape:
		gtk_main_quit();
		break;
	default:
		break;
	}
	return FALSE;
}


gint
win_get_clipbrd(gchar *paste)
{
	GtkClipboard *clipbrd;
	gchar *result;

	clipbrd = gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);

	if(clipbrd == NULL){
		return 0;
	}

	result = gtk_clipboard_wait_for_text(clipbrd);
	if(result){
		if(strlen(result) >= SIZE_LIMIT){
			gchar warning[SIZE_LIMIT] = "\0";
			sprintf(warning, OUT_OF_BOUND_FMT, SIZE_LIMIT);
			strcpy(paste, warning);
			return -1;
		}
		strcpy(paste, result);
		g_free(result);
		return 1;
	}
	return 0;
}
